package hatenahaiku4j;

import hatenahaiku4j.util.HttpUtil.PostStream;

import java.io.File;
import java.io.IOException;

/**
 * XVpp[^\NXłB
 * 
 * @since v0.0.1
 * @author fumokmm
 */
public class UpdateParameter {
	/** ee */
	private String text;
	/** ԐMXe[^XID */
	private String inReplyToStatusId;
	/** eL[[h */
	private String keyword;
	/** 摜t@C */
	private File file;
	/** 摜t@CURL */
	private String imageUrl;
	/** 摜f[^ */
	private byte[] imageData;
	/** 摜f[^gq */
	private ImageExt imageDataExt;
	
	/**
	 * RXgN^łB
	 * 
	 * @since v0.0.1
	 */
	UpdateParameter() {}
	
	/**
	 * eeԋp܂B
	 * 
	 * @return ee
	 * @since v0.0.1
	 */
	public String getText() {
		return text;
	}

	/**
	 * eeݒ肵܂B
	 * 
	 * @param text ee
	 * @since v0.0.1
	 */
	public void setText(String text) {
		this.text = text;
	}
	
	/**
	 * ԐMXe[^XID擾܂B
	 * 
	 * @return ԐMXe[^XID
	 * @since v0.0.1
	 */
	public String getInReplyToStatusId() {
		return inReplyToStatusId;
	}

	/**
	 * ԐMXe[^XIDݒ肵܂B
	 * 
	 * @param inReplyToStatusId ԐMXe[^XID
	 * @since v0.0.1
	 */
	public void setInReplyToStatusId(String inReplyToStatusId) {
		this.inReplyToStatusId = inReplyToStatusId;
	}

	/**
	 * eL[[h擾܂B
	 * 
	 * @return eL[[h
	 * @since v0.0.1
	 */
	public String getKeyword() {
		return keyword;
	}

	/**
	 * eL[[hݒ肵܂B
	 * 
	 * @param keyword eL[[h
	 * @since v0.0.1
	 */
	public void setKeyword(String keyword) {
		this.keyword = keyword;
	}
	
	/**
	 * 摜t@C
	 * 
	 * @return 摜t@C
	 * @since v0.0.1
	 */
	public File getFile() {
		return file;
	}
	
	/**
	 * 摜t@Cݒ肵܂B
	 * 
	 * @param file 摜t@C
	 * @since v0.0.1
	 */
	public void setFile(File file) {
		this.file = file;
	}

	/**
	 * 摜t@CURL
	 * 
	 * @return 摜t@CURL
	 * @since v1.0.0
	 */
	public String getImageUrl() {
		return imageUrl;
	}
	
	/**
	 * 摜t@CURLݒ肵܂B
	 * 
	 * @param imageUrl 摜t@CURL
	 * @since v1.0.0
	 */
	public void setImageUrl(String imageUrl) {
		this.imageUrl = imageUrl;
	}
	
	/**
	 * 摜f[^
	 * 
	 * @return 摜t@CURL
	 * @since v1.0.0
	 */
	public byte[] getImageData() {
		return imageData;
	}
	
	/**
	 * 摜f[^ݒ肵܂B
	 * 
	 * @param imageData 摜f[^
	 * @since v1.0.0
	 */
	public void setImageData(byte[] imageData) {
		this.imageData = imageData;
	}

	/**
	 * 摜f[^gq
	 * 
	 * @return 摜f[^gq
	 * @since v1.0.0
	 */
	public ImageExt getImageDataExt() {
		return imageDataExt;
	}
	
	/**
	 * 摜f[^gqݒ肵܂B
	 * 
	 * @param imageDataExt 摜f[^gq
	 * @since v1.0.0
	 */
	public void setImageDataExt(ImageExt imageDataExt) {
		this.imageDataExt = imageDataExt;
	}
	
	//-----------------------------------
	/** status */
	private static final String PARAM_KEY_STATUS = "status";
	/** in_reply_to_status_id */
	private static final String PARAM_KEY_IN_REPLY_TO_STATUS_ID = "in_reply_to_status_id";
	/** keyword */
	private static final String PARAM_KEY_KEYWORD = "keyword";
	/** file */
	private static final String PARAM_KEY_FILE = "file";
	/** source */
	private static final String PARAM_KEY_SOURCE = "source";

	/**
	 * |Xgp[^ݒ肵܂B
	 * 
	 * @param loginUser OC[U
	 * @param ps |Xg⏕NX
	 * @throws IOException 
	 * @since v1.0.0
	 */
	public void addParameter(LoginUser loginUser, PostStream ps) throws IOException {
		// status
		ps.addProperty(PARAM_KEY_STATUS, text);

		// keyword
		if (keyword == null || keyword.equals("")) {
			ps.addProperty(PARAM_KEY_KEYWORD, loginUser.getUserIdNotation());
		} else {
			ps.addProperty(PARAM_KEY_KEYWORD, keyword);
		}
		
		// source
		ps.addProperty(PARAM_KEY_SOURCE, loginUser.getSource());
		
		// in_reply_to_status_id
		if (inReplyToStatusId != null && !inReplyToStatusId.equals("")) {
			ps.addProperty(PARAM_KEY_IN_REPLY_TO_STATUS_ID, inReplyToStatusId);
		}
		
		// file
		if (file != null) {
			ImageMime mime = ImageMime.getImageMime(file.getName());
			if (mime != null) {
				ps.addFile(file, PARAM_KEY_FILE, mime);
			}
		}
		
		// imageUrl
		if (imageUrl != null) {
			ImageMime mime = ImageMime.getImageMime(imageUrl);
			if (mime != null) {
				ps.addImageUrl(imageUrl, PARAM_KEY_FILE, mime);
			}
		}
		
		// imageData
		if (imageData != null && imageDataExt != null) {
			ImageMime mime = ImageMime.getImageMime(imageDataExt);
			if (mime != null) {
				ps.addImageData(imageData, PARAM_KEY_FILE, mime);
			}
		}
	}

	/**
	 * |Xge\܂B
	 * 
	 * @since v0.0.1
	 */
	public void outputPostInfo(LoginUser loginUser) {
		// |Xge̕\
		System.out.println("[keyword: " + keyword + "]");
		System.out.println("[inReplyToStatusId: " + inReplyToStatusId + "]");
		System.out.println("[source: " + loginUser.getSource() + "]");
		System.out.println("[text: " + text + "]");
		System.out.println("[file: " + (file == null ? "null" : file.getName()) + "]");
		System.out.println("[imageUrl: " + imageUrl + "]");
		System.out.println("[imageDataExt: " + imageDataExt + "]");
	}
}
