package hatenahaiku4j.util;

import hatenahaiku4j.Const;

/**
 * ͂ĂȃnCNURL𐶐郆[eBeBNXłB
 * 
 * @author fumokmm
 * @since v1.0.1
 */
public class HaikuURL {

	//----------------------------------------------
	// Fields
	
	/** N */
	private String link;
	/** oCp̃N */
	private String mobileLink;
	
	/** GXP[vꂽN */
	private String escapedLink;
	/** oCp̃GXP[vꂽN */
	private String escapedMobileLink;

	//----------------------------------------------
	// Constructors

	/* vCx[gRXgN^ */
	private HaikuURL() {
		this.link = "";
		this.mobileLink = "";
		this.escapedLink = "";
		this.escapedMobileLink = "";
	}
	
	//----------------------------------------------
	// Create Methods

	/**
	 * L[[hw肵āAHaikuURL𐶐܂B<br/>
	 * L[[h󂾂ꍇAHaikuURL܂B
	 * 
	 * @param keyword L[[h
	 * @return L[[hHaikuURL
	 * @since v1.0.1
	 */
	public static HaikuURL byKeyword(String keyword) {
		return _byKeyword(keyword, null);
	}

	/**
	 * L[[hƃxw肵āAHaikuURL𐶐܂B<br/>
	 * GXP[v̓xɎ{܂B<br/>
	 * L[[h󂾂ꍇAHaikuURL܂B
	 * 
	 * @param keyword L[[h
	 * @param label Nu郉x
	 * @return L[[hHaikuURL
	 * @since v1.0.1
	 */
	public static HaikuURL byKeyword(String keyword, String label) {
		return _byKeyword(keyword, label);
	}
	
	/**
	 * L[[hƃxw肵āAHaikuURL𐶐܂B<br/>
	 * GXP[v̓xɎ{܂B<br/>
	 * x󂾂ꍇAʏ̃L[[hN{܂B<br/>
	 * L[[h󂾂ꍇAHaikuURL܂B
	 * 
	 * @param keyword L[[h
	 * @param label Nu郉x
	 * @return L[[hHaikuURL
	 * @since v1.0.1
	 */
	private static HaikuURL _byKeyword(String keyword, String label) {
		HaikuURL haikuUrl = new HaikuURL();
		if (StringUtil.isEmpty(keyword)) {
			return haikuUrl;
		}
		// xƂ́AxURLNɂ
		if (StringUtil.isEmpty(label)) {
			haikuUrl.link				= toKeywordLink(keyword);
			haikuUrl.mobileLink			= toKeywordLink(keyword);
			haikuUrl.escapedLink		= toUrlLink(Const.KEYWORD_BASE_URL,			keyword, keyword, true);
			haikuUrl.escapedMobileLink	= toUrlLink(Const.MOBILE_KEYWORD_BASE_URL,	keyword, keyword, true);
		} else {
			haikuUrl.link				= toUrlLink(Const.KEYWORD_BASE_URL,			keyword, label, false);
			haikuUrl.mobileLink			= toUrlLink(Const.MOBILE_KEYWORD_BASE_URL,	keyword, label, false);
			haikuUrl.escapedLink		= toUrlLink(Const.KEYWORD_BASE_URL,			keyword, label, true);
			haikuUrl.escapedMobileLink	= toUrlLink(Const.MOBILE_KEYWORD_BASE_URL,	keyword, label, true);
		}
		return haikuUrl;
	}
	
	/**
	 * [UIDw肵āAHaikuURL𐶐܂B<br/>
	 * [UID󂾂ꍇAHaikuURL܂B
	 * 
	 * @param userId [UID
	 * @return [UIDHaikuURL
	 * @since v1.0.1
	 */
	public static HaikuURL byUserId(String userId) {
		return _byUserId(userId, null);
	}
	
	/**
	 * [UIDƃxw肵āAHaikuURL𐶐܂B<br/>
	 * GXP[v̓xɎ{܂B<br/>
	 * [UID󂾂ꍇAHaikuURL܂B
	 * 
	 * @param userId [UID
	 * @param label Nu郉x
	 * @return [UIDHaikuURL
	 * @since v1.0.1
	 */
	public static HaikuURL byUserId(String userId, String label) {
		return _byUserId(userId, label);
	}
	
	/**
	 * [UIDƃxw肵āAHaikuURL𐶐܂B<br/>
	 * GXP[v̓xɎ{܂B<br/>
	 * x󂾂ꍇAʏ̃[UIDN{܂B<br/>
	 * [UID󂾂ꍇAHaikuURL܂B
	 * 
	 * @param userId [UID
	 * @param label Nu郉x
	 * @return [UIDHaikuURL
	 * @since v1.0.1
	 */
	private static HaikuURL _byUserId(String userId, String label) {
		HaikuURL haikuUrl = new HaikuURL();
		if (StringUtil.isEmpty(userId)) {
			return haikuUrl;
		}
		// xƂ́AxIDNɂ
		if (StringUtil.isEmpty(label)) {
			haikuUrl.link				= toIdLink(userId);
			haikuUrl.mobileLink			= toIdLink(userId);
			haikuUrl.escapedLink		= toUrlLink(Const.BASE_URL,			userId, Const.ID_COLON + userId, true);
			haikuUrl.escapedMobileLink	= toUrlLink(Const.MOBILE_BASE_URL,	userId, Const.ID_COLON + userId, true);
		} else {
			haikuUrl.link				= toUrlLink(Const.BASE_URL,			userId, label, false);
			haikuUrl.mobileLink			= toUrlLink(Const.MOBILE_BASE_URL,	userId, label, false);
			haikuUrl.escapedLink		= toUrlLink(Const.BASE_URL,			userId, label, true);
			haikuUrl.escapedMobileLink	= toUrlLink(Const.MOBILE_BASE_URL,	userId, label, true);
		}
		return haikuUrl;
	}

	/**
	 * ASINR[hw肵āAasinL@HaikuURL𐶐܂B
	 * 
	 * @param asinCode ASINR[h
	 * @return asinL@HaikuURL
	 * @since v1.0.1
	 */
	public static HaikuURL byASIN(String asinCode) {
		HaikuURL haikuUrl = new HaikuURL();
		if (StringUtil.isEmpty(asinCode)) {
			return haikuUrl;
		}
		String link = toASINLink(asinCode);
		haikuUrl.link				= link;
		haikuUrl.mobileLink			= link;
		haikuUrl.escapedLink		= link;
		haikuUrl.escapedMobileLink	= link;
		return haikuUrl;
	}

	/**
	 * YouTube"watch?v="ȍ~̓IDw肵āAyoutubeHaikuURL𐶐܂B
	 * 
	 * @param youtubeId YouTube̓ID
	 * @return YouTubẽNHaikuURL
	 * @since v1.0.1
	 */
	public static HaikuURL byYouTube(String youtubeId) {
		HaikuURL haikuUrl = new HaikuURL();
		if (StringUtil.isEmpty(youtubeId)) {
			return haikuUrl;
		}
		String link = toYouTubeLink(youtubeId);
		haikuUrl.link				= link;
		haikuUrl.mobileLink			= link;
		haikuUrl.escapedLink		= link;
		haikuUrl.escapedMobileLink	= link;
		return haikuUrl;
	}

	/**
	 * jRjR̓ID("sm``"`)w肵āAjRjRURL𐶐܂B
	 * 
	 * @param nico2Id jRjR̓ID
	 * @return jRjR̃NHaikuURL
	 * @since v1.0.1
	 */
	public static HaikuURL byNico2(String nico2Id) {
		HaikuURL haikuUrl = new HaikuURL();
		if (StringUtil.isEmpty(nico2Id)) {
			return haikuUrl;
		}
		String link = toNico2Link(nico2Id);
		haikuUrl.link				= link;
		haikuUrl.mobileLink			= link;
		haikuUrl.escapedLink		= link;
		haikuUrl.escapedMobileLink	= link;
		return haikuUrl;
	}

	/**
	 * URLw肵āAHaikuURL𐶐܂B<br/>
	 * URL񂪋󂾂ꍇAHaikuURL܂B
	 * 
	 * @param url URL
	 * @return URLHaikuURL
	 * @since v1.0.1
	 */
	public static HaikuURL byURL(String url) {
		return _byURL(url, null);
	}

	/**
	 * URLƃxw肵āAHaikuURL𐶐܂B<br/>
	 * GXP[v̓xɎ{܂B<br/>
	 * URL񂪋󂾂ꍇAHaikuURL܂B
	 * 
	 * @param url URL
	 * @param label Nu郉x
	 * @return URLHaikuURL
	 * @since v1.0.1
	 */
	public static HaikuURL byURL(String url, String label) {
		return _byURL(url, label);
	}
	
	/**
	 * URLƃxw肵āAHaikuURL𐶐܂B<br/>
	 * GXP[v̓xɎ{܂B<br/>
	 * x󂾂ꍇAʏ̃NƂȂ܂B<br/>
	 * URL񂪋󂾂ꍇAHaikuURL܂B
	 * 
	 * @param url URL
	 * @param label Nu郉x
	 * @return URLHaikuURL
	 * @since v1.0.1
	 */
	private static HaikuURL _byURL(String url, String label) {
		HaikuURL haikuUrl = new HaikuURL();
		if (StringUtil.isEmpty(url)) {
			return haikuUrl;
		}
		if (StringUtil.isEmpty(label)) {
			haikuUrl.link				= url;
			haikuUrl.mobileLink			= url;
			haikuUrl.escapedLink		= toUrlLink(null, url, url, true);
			haikuUrl.escapedMobileLink	= toUrlLink(null, url, url, true);
		} else {
			haikuUrl.link				= toUrlLink(null, url, label, false);
			haikuUrl.mobileLink			= toUrlLink(null, url, label, false);
			haikuUrl.escapedLink		= toUrlLink(null, url, label, true);
			haikuUrl.escapedMobileLink	= toUrlLink(null, url, label, true);
		}
		return haikuUrl;
	}

	//----------------------------------------------
	// Getter/Setter Methods

	/**
	 * N擾܂B
	 * 
	 * @return N
	 * @since v1.0.1
	 */
	public String getLink() {
		return this.link;
	}

	/**
	 * GXP[vꂽN擾܂B
	 * 
	 * @return GXP[vꂽN
	 * @since v1.0.1
	 */
	public String getEscapedLink() {
		return this.escapedLink;
	}

	/**
	 * oCpN擾܂B
	 * 
	 * @return oCpN
	 * @since v1.0.1
	 */
	public String getMobileLink() {
		return this.mobileLink;
	}

	/**
	 * oCpGXP[vꂽN擾܂B
	 * 
	 * @return oCpGXP[vꂽN
	 * @since v1.0.1
	 */
	public String getEscapedMobileLink() {
		return this.escapedMobileLink;
	}

	//----------------------------------------------
	// Utility Methods
	
	/**
	 * L[[hNɕϊ܂B
	 * 
	 * @param keyword L[[h
	 * @return L[[hN
	 * @since v1.0.1
	 */
	private static String toKeywordLink(String keyword) {
		return "[[" + keyword + "]]";
	}
	
	/**
	 * IDNɕϊ܂B
	 * 
	 * @param userId [UID
	 * @return IDN
	 * @since v1.0.1
	 */
	private static String toIdLink(String userId) {
		return Const.ID_COLON + userId;
	}
	
	/**
	 * ASINL@URLɕϊ܂B
	 * 
	 * @param asinCode ASINR[h
	 * @return ASINL@URL
	 * @since v1.0.1
	 */
	private static String toASINLink(String asinCode) {
		return "asin:" + asinCode;
	}

	/**
	 * YouTubeL@URLɕϊ܂B
	 * 
	 * @param youtubeId YouTube̓ID
	 * @return YouTubeL@URL
	 * @since v1.0.1
	 */
	private static String toYouTubeLink(String youtubeId) {
		return "http://www.youtube.com/watch?v=" + youtubeId;
	}
	
	/**
	 * jRjRL@URLɕϊ܂B
	 * 
	 * @param nico2Id jRjR̓ID
	 * @return jRjRL@URL
	 * @since v1.0.1
	 */
	private static String toNico2Link(String nico2Id) {
		return "http://www.nicovideo.jp/watch/" + nico2Id;
	}
	
	/**
	 * URLNL@URLɕϊ܂B
	 * 
	 * @param baseUrl x[XURL
	 * @param info 
	 * @param label x
	 * @param needEscape GXP[vv
	 * @return URLNL@URL
	 * @since v1.0.1
	 */
	private static String toUrlLink(String baseUrl, String info, String label, boolean needEscape) {
		String url = StringUtil.isEmpty(baseUrl) ?
				shortenURL(info) :
				shortenURL(baseUrl + encode(info));
		// URL\z(URLL@)
		return needEscape ?
			"[" + url + ":title=" + escape(label) + "]" :
			"[" + url + ":title=" + label + "]";
	}

	/**
	 * URLGR[h{
	 * 
	 * @see StringUtil#encode(String)
	 * @param str URLEncode镶
	 * @return GR[hꂽ
	 * @since v1.0.1
	 */
	private static String encode(String str) {
		return StringUtil.encode(str);
	}

	/**
	 * :Ȃǂ̕GXP[v
	 * 
	 * @see HatenaUtil#escapeHatenaNotation(String)
	 * @param str GXP[vΏۂ̕
	 * @return GXP[v
	 * @since v1.0.1
	 */
	private static String escape(String str) {
		return HatenaUtil.escapeHatenaNotation(str);
	}

	/**
	 * URLZkB
	 * 
	 * @param str ZkΏۂURL
	 * @return ZkURL
	 */
	private static String shortenURL(String str) {
		return str;
	}
}
