package hatenahaiku4j.util;

import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 * ͂Ăȃ[eBeBNX
 * 
 * @since v0.0.1
 * @author fumokmm
 */
public class HatenaUtil {

	/**
	 * IDp^[<br>
	 * <ul>
	 * <li>[Uid͔ppAnCti - jAA_[o[i _ j</li>
	 * <li>擪̓At@xbg</li>
	 * <li>̓At@xbg</li>
	 * <li>3ȏ</li>
	 * </ul>
	 * 
	 * @since v0.0.1
	 */
	private static final String ID_NOTATION_PATTERN = "id:[a-zA-Z][a-zA-Z0-9_-]{1,}[a-zA-Z0-9]";

	/** ͂ĂȕWttH[}bg(yyyy-MM-dd HH:mm:ss) */
	private static final DateFormat HATENA_DEFAULT_DATE_FORMAT = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");

	/**
	 * w肳ꂽ񂪂͂ĂIDp^[Ƀ}b`邩ǂ肵܂B
	 * 
	 * @param idStr ͂ĂIDp^[
	 * @return ͂ĂIDp^[̏ꍇtrue, łȂfalse
	 * @since v0.2.0
	 */
	public static boolean isIdNotation(String idStr) {
		if (idStr == null) return false;
		return idStr.matches("^" + ID_NOTATION_PATTERN + "$");
	}

	/**
	 * ͂ĂȕWttH[}bg`iF2009-09-14 20:18:59){WDateɕϊ܂B
	 * 
	 * @param dateString ͂ĂȕWttH[}bg`̕
	 * @return {WDate
	 * @since v0.2.0
	 */
	public static Date parseDate(String dateString) {
		try {
			return DateUtil.adjustToJST(HATENA_DEFAULT_DATE_FORMAT.parse(dateString));
		} catch (ParseException e) {
			return null;
		}
	}
	
	/**
	 * Date͂ĂȕWttH[}bg`iF2009-09-14 20:18:59)̕ɕϊ܂B
	 * 
	 * @param date t
	 * @return ͂ĂȕWttH[}bg`̕
	 * @since v0.2.0
	 */
	public static String formatDate(Date date) {
		return HATENA_DEFAULT_DATE_FORMAT.format(date);
	}
	
	/** ͂ĂȋL@R[h */
	private static final String HATENA_NOTATION_CODE = new String(new char[]{
			'"',
			'&',
			'\'',
			'\\','(',
			'\\',')',
			':',
			';',
			'<',
			'=',
			'>',
			'\\','[',
			'\\',']',
	});

	/** ͂ĂȋL@R[hp^[ */
	private static final Pattern HATENA_NOTATION_CODE_PATTERN = Pattern.compile("(?s)([" + HATENA_NOTATION_CODE + "])");
	
	/**
	 * u:vu[]vu:vȂǂ̂͂ĂȋL@Ŏgp镶HTMLGXP[v܂B<br/>
	 * 𗘗p邱ƂŁAႦid:xxxidxxxƂȂ邽߁AidR[ȂȂ܂B<br/>
	 * <br/>
	 * GXP[v镶<br/>
	 * <ul>
	 * <li>"  &amp;#34;</li>
	 * <li>&  &amp;#38;</li>
	 * <li>'  &amp;#39;</li>
	 * <li>(  &amp;#40;</li>
	 * <li>)  &amp;#41;</li>
	 * <li>:  &amp;#58;</li>
	 * <li>;  &amp;#59;</li>
	 * <li><  &amp;#60;</li>
	 * <li>=  &amp;#61;</li>
	 * <li>>  &amp;#62;</li>
	 * <li>[  &amp;#91;</li>
	 * <li>]  &amp;#93;</li>
	 * </ul>
	 * 
	 * @param str GXP[vΏۂ̕
	 * @return GXP[v
	 * @since v1.0.1
	 */
	public static String escapeHatenaNotation(String str) {
		Matcher matcher = HATENA_NOTATION_CODE_PATTERN.matcher(str);
		StringBuffer sb = new StringBuffer();
		while (matcher.find()) {
			matcher.appendReplacement(sb, "&#" + String.valueOf((int) matcher.group(0).charAt(0)) + ";");
		}
	    matcher.appendTail(sb);
	    return sb.toString();
	}
}
